<link rel="import" href="../polymer/polymer.html">
<link rel="import" href="../iron-ajax/iron-ajax.html">
<link rel="import" href="../neon-animation/animations/cascaded-animation.html">
<link rel="import" href="../neon-animation/animations/fade-in-animation.html">
<link rel="import" href="../neon-animation/animations/fade-out-animation.html">
<link rel="import" href="../neon-animation/animations/hero-animation.html">
<link rel="import" href="../palmetto-kendo/height-increase-animation.html">
<link rel="import" href="../palmetto-kendo/height-decrease-animation.html">
<link rel="import" href="../neon-animation/animations/scale-up-animation.html">
<link rel="import" href="../neon-animation/animations/slide-from-left-animation.html">
<link rel="import" href="../neon-animation/animations/slide-from-right-animation.html">
<link rel="import" href="../neon-animation/animations/slide-left-animation.html">
<link rel="import" href="../neon-animation/animations/slide-right-animation.html">
<link rel="import" href="../neon-animation/animations/slide-down-animation.html">
<link rel="import" href="../neon-animation/animations/slide-up-animation.html">
<link rel="import" href="../neon-animation/animations/transform-animation.html">
<link rel="import" href="../neon-animation/neon-animatable.html">
<link rel="import" href="../neon-animation/neon-animation.html">
<link rel="import" href="../neon-animation/neon-animations.html">
<link rel="import" href="../neon-animation/neon-animated-pages.html">
<link rel="import" href="../neon-animation/neon-animation-runner-behavior.html">
<link rel="import" href="../moment-imports/moment-imports.html">


<script>
/**
 *
 *
 *
 * @polymerBehavior PalmettoBehaviors.PalmettoAppBehavior
 **/
window.PalmettoBehaviors = window.PalmettoBehaviors || {};
PalmettoBehaviors.PalmettoAppBehavior = PalmettoBehaviors.PalmettoAppBehavior || {
  properties: {
      // use app-name to specify the name of the app instance. This will aid window manager.
      palmettoAppName: {
          type: String
      },
      /**
       * This variable is used for renderring the menu icon when the app is maximized
       */
      _maximized: {
          type: Boolean,
          notify:true,
          value: false
      },
      showDrawer: {
          type: Boolean,
          notify: true,
          value: false
      }
  },
  behaviors: [
      Polymer.NeonAnimationRunnerBehavior,
      Polymer.IronResizableBehavior,
  ],
  hide: function(e){
      this.fire("hide-window",{element:this.elementType});
  },
  maximize: function(e) {
      this.fire("maximize-window",{element:this.elementType});
      this.set("_maximized",true);
      this._onIronResize();

  },
  restore: function(e) {
      this.set("_maximized",false);
      this.fire("restore-window",{element:this.elementType});
      this._onIronResize();
  },

  /**
   * This function checks if it should render the menu icon based on two criteria
   * So if the app is not hosted, render the menu icon,
   * or if the app is maximized, render the menu
   * @param {Boolean} isHosted this is the determination if app is hosted in palmetto
   * @param {Boolean} isMaximized this is the determination if the app is maximized or not (Only in palmetto)
   * @returns {Boolean} The determination whether to render the window or not
    */
  _checkWaffle: function(isHosted, isMaximized) {
      if(isHosted === false || isMaximized) {
          return true;
      }
      return false;
  },
  ajaxResponse: function(e){
  },
  rowdataChanged: function(rowdata) {
    if(typeof rowdata == "null" || rowdata == null)
      return;
    //add data to a new form!!!
    this.set("temprowdata", rowdata);
    this._addTab(rowdata);
    this.rowdata = null;
  },
  subscriptionUpdate: function(event) {
    var temp = [];
    this.dataset = [];
    temp = event.detail;
    this.set('dataset', temp);
    // this.notifySplices('dataset');
	if(this.updateRowDetails) {
		this.updateRowDetails();
	}
  },
  attached: function() {
      if(this.moreOptionsItems) {
          this.moreOptionsItems.forEach(function (item) {
              if((item.name === "Help") || (item.event === "help")) {
                  item.href = window.PALMETTO_CONFIGURATION.APP_API_URL + "/api/system/documenation?document=" + this.$.appHeader.appTitle + "&access_token=" + window.palmettoToken.id;
              }
          }.bind(this));

          this.set("moreOptionsItems", JSON.parse(JSON.stringify(this.moreOptionsItems)));
      }
  },

  _onGridIconTap: function (event) {
      // Show the grid.
      this.$.ironPages.selectIndex(0);
  },
  _onExcelTap: function (event) {
      //if we're on the grid, download the page, otherwise, make an ajax call to
      //the backend
      if(this.$.ironPages.selected == 0) {
        //If we are in palmetto units, find out which columns to display
        //If there are OH columns, add tabs for the 24hr and 48hr columns as well
        if(this._pvisionElementType == "units" && this.configuration && this.configuration.APP_CONFIG && this.configuration.APP_CONFIG.id == "palmetto") {
            //get filtered/sorted data regardless of page number
            var datasource = $(this.$.kendo.$.grid).data("kendoGrid").dataSource;
            var filteredData = new kendo.data.DataSource({
                data: datasource.data(),
                filter: datasource.filter()
            });
            filteredData.read();
            filteredData = filteredData.view();

            //get all visible columns
            var cols = $(this.$.kendo.$.grid).data("kendoGrid").columns;
            var visibleCols = [];
            cols.forEach(function(col) {
                if(!col.hidden)
                    visibleCols.push(col);
            });

            //initialize the sheets object
            var sheets = [
                {
                    columns: [],
                    title: "Units",
                    rows: [
                        {
                            cells: []
                        }
                    ]
                }
            ];

            //Print the units excel as kendo normally does it
            //BUT if an OH column is enabled, add two sheets for req 24 and 48
            var create24and48 = false;
            for(var i = 0; i < visibleCols.length; i++) {
                if(visibleCols[i].field.indexOf('oh') != -1) {
                    sheets[0].title = "OH";
                    create24and48 = true;
                    break;
                }
            }
            //this adds the sheets if OH columns are found
            if(create24and48) {
                sheets.push({
                    columns: [],
                    title: "REQ-24",
                    rows: [
                        {
                            cells: []
                        }
                    ]
                });
                sheets.push({
                    columns: [],
                    title: "REQ-48",
                    rows: [
                        {
                            cells: []
                        }
                    ]
                });
            }
            for(var sheetNum = 0; sheetNum < sheets.length; sheetNum++) {
                //column headers
                for(var i = 0; i < visibleCols.length; i++) {
                    sheets[sheetNum].columns.push({autoWidth: true});
                    var obj = {background: "#808080", color:"#FFFFFF"};
                    //Change title depending on the sheet number (OH, REQ-24, or REQ-48)
                    switch(sheetNum) {
                        case 0:
                            obj.value = visibleCols[i].title;
                            break;
                        case 1:
                            obj.value = visibleCols[i].title.replace("OH","REQ-24");
                            break;
                        case 2:
                            obj.value = visibleCols[i].title.replace("OH","REQ-48");
                            break;
                    }
                    sheets[sheetNum].rows[0].cells.push(obj);
                }
                for(var k = 0; k < filteredData.length; k++) {
                    var cells = [];
                    for(var i = 0; i < visibleCols.length; i++) {
                        switch(sheetNum) {
                            //handle OH
                            case 0:
                                cells.push({value: filteredData[k][visibleCols[i].field]});
                                break;
                            //handle req 24
                            case 1:
                                var ohInd = visibleCols[i].field.indexOf('oh');
                                if(ohInd != -1) {
                                    //determine the field to look for the data object
                                    var tempField = visibleCols[i].field.replace("oh","req24");
                                    var displayedInd = tempField.indexOf('displayed');
                                    if(displayedInd != -1) {
                                        tempField = tempField.substring(0,displayedInd);
                                    }
                                    //get the value for that field and parse it
                                    var tempVal = filteredData[k][tempField];
                                    var val = "";
                                    var comma = -1;
                                    if(tempVal) {
                                        comma = tempVal.indexOf(',');
                                    }
                                    //if a comma is found, this means it has a unit of measurement defined
                                    //we should print that number with the unit of measurement
                                    if(comma != -1 && parseInt(tempVal) > 0) {
                                        val = tempVal.substring(0,comma) + ' ' + tempVal.substring(comma+1,tempVal.length) + '(s)';
                                    //otherwise, there is no unit. if the number is > 0 just print it with a generic unit
                                    } else if(comma == -1 && parseInt(tempVal) > 0) {
                                        val = parseInt(tempVal) + " unit(s)";
                                    }
                                    //if the number wasn't > 0, we do not print it
                                    cells.push({value: val});
                                } else {
                                    cells.push({value: filteredData[k][visibleCols[i].field]});
                                }
                                break;
                            //handle req 48
                            case 2:
                                var ohInd = visibleCols[i].field.indexOf('oh');
                                if(ohInd != -1) {
                                    //determine the field to look for the data object
                                    var tempField = visibleCols[i].field.replace("oh","req48");
                                    var displayedInd = tempField.indexOf('displayed');
                                    if(displayedInd != -1) {
                                        tempField = tempField.substring(0,displayedInd);
                                    }
                                    //get the value for that field and parse it
                                    var tempVal = filteredData[k][tempField];
                                    var val = "";
                                    var comma = -1;
                                    if(tempVal) {
                                        comma = tempVal.indexOf(',');
                                    }
                                    //if a comma is found, this means it has a unit of measurement defined
                                    //we should print that number with the unit of measurement
                                    if(comma != -1 && parseInt(tempVal) > 0) {
                                        val = tempVal.substring(0,comma) + ' ' + tempVal.substring(comma+1,tempVal.length) + '(s)';
                                    //otherwise, there is no unit.  if the number is > 0 just print it with a generic unit
                                    } else if(comma == -1 && parseInt(tempVal) > 0) {
                                        val = parseInt(tempVal) + " unit(s)";
                                    }
                                    //if the number wasn't > 0, we do not print it
                                    cells.push({value: val});
                                } else {
                                    cells.push({value: filteredData[k][visibleCols[i].field]});
                                }
                                break;
                        }
                    }
                    sheets[sheetNum].rows.push({cells: cells});
                }
            }
            //build the xlsx with our sheets array
            var wrkbk = new kendo.ooxml.Workbook({
                sheets: sheets
            });
            //trigger the download
            kendo.saveAs({
                dataURI: wrkbk.toDataURL(),
                fileName: "Units.xlsx"
            });
        } else {
            this.$.kendo.grid.saveAsExcel();
        }
      } else if(this.currentDataId < 0){
        return;
      } else {
        window.open(window.PALMETTO_CONFIGURATION.APP_API_URL + "/api/" + this._pvisionElementType + "/" + this.currentDataId + "/print/?access_token=" + this.palmettoToken.id, "_blank");
      }

  },
  _onPdfTap: function (event) {
      this.$.kendo.grid.saveAsPDF();
  },
  _onTabAnimationFinish: function () {
      this._paperTabs = this.querySelector('zawarski-paper-tabs');
      if (this._tabsShowing) {
          this._paperTabs.style.height = "40px";
          this.tabsopen = true;
          setTimeout(function () {
              this._onIronResize();
          }.bind(this), 1000);
      } else {
          this._paperTabs.style.height = "0px";
          this.tabsopen = false;
          setTimeout(function () {
              this._onIronResize();
          }.bind(this), 1000);

      }
  },
  _onIronResize: function() {
      var kendo = Polymer.dom(this.root).querySelector('palmetto-kendo-grid-new');
      if(kendo) {
          kendo.resize();
      }
  },
  _onSelectedTabIndexChange: function (index) {
      // (should not need to call these next two lines so often?)
      this._paperTabs = this.querySelector('zawarski-paper-tabs');
      this._pvisionForm = Polymer.dom(this.root).querySelector('#' + this.elementType + 'Form');
      // this._pvisionForm = this.$.sheltersForm;
      if (this._pvisionForm != null) {
          // this._pvisionForm.style = "height:100%;";
          var that = this;
          setTimeout(function () {
              if (index >= 0) {
                  var paperTab = that._paperTabs.items[index];
                  if (index == 0 || paperTab == undefined || paperTab.id == 'gridTab') {
                      // Switch from form to grid.
                      that.$.ironPages.selectIndex(0);
                      if (that._paperTabs.items.length == 1) {
                          // Only grid tab left. Hide tabs.
                          that.hideTabs();
                      }
                      return;
                  }
              }
              // Load appropriate form.
              var paperTabID = that._paperTabs.selectedItem.id;
              var pvDataID = paperTabID.substring(paperTabID.indexOf('tab') + 4);
              that._pvisionForm.temprowdata = this.temprowdata;
              that._pvisionForm.selectEntry(pvDataID);
              this.currentDataId = pvDataID;
          }.bind(this), 1);

          // Make the form page visible.
          if (!this._tabsShowing) {
              this.showTabs();
          }
          // Show the form.
          this.$.ironPages.selectIndex(1);
      }
  },
  drawerTap: function() {
      if(this._maximized) {
        window.dispatchEvent(new CustomEvent('jewelry-box-toggle-event'));
      }
      this.showDrawer = !this.showDrawer;
      this.fire("drawerTapStandalone");
  },
	/*
  _isVanguard: function(config) {
      if(Object.keys(config).length === 0 && config.constructor === Object)
        return false;
      if(config.APP_CONFIG.id=="vanguard")
        return true;
      else
        return false;
  },
  */
  _isVanguard: function () {
	return window.PALMETTO_CONFIGURATION &&
		((window.PALMETTO_CONFIGURATION.APP_TYPE &&
			window.PALMETTO_CONFIGURATION.APP_TYPE.toLowerCase().indexOf('vang') !== -1) ||
			(window.PALMETTO_CONFIGURATION.APP_TYPE &&
				window.PALMETTO_CONFIGURATION.APP_NAME.toLowerCase().indexOf('vang') !== -1));
  },
  _isMobile: function() {
      return (/Mobi|Android/i.test(navigator.userAgent));
  },
  _isWab: function(config) {
      if(Object.keys(config).length === 0 && config.constructor === Object)
        return false;
      if(config.APP_BASEMAP_TYPE == "leaflet")
        return false;
      else
        return true;
  },

  _isInternetExplorer: function() {
	var ua = window.navigator.userAgent;
	// Test values; Uncomment to check result …
	// IE 10
	// ua = 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; Trident/6.0)';

	// IE 11
	// ua = 'Mozilla/5.0 (Windows NT 6.3; Trident/7.0; rv:11.0) like Gecko';

	// Edge 12 (Spartan)
	// ua = 'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/39.0.2171.71 Safari/537.36 Edge/12.0';

	// Edge 13
	// ua = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/46.0.2486.0 Safari/537.36 Edge/13.10586';

	var msie = ua.indexOf('MSIE ');
	if (msie > 0) {
		// IE 10 or older => return version number
		return parseInt(ua.substring(msie + 5, ua.indexOf('.', msie)), 10);
	}

	var trident = ua.indexOf('Trident/');
	if (trident > 0) {
		// IE 11 => return version number
		var rv = ua.indexOf('rv:');
		return parseInt(ua.substring(rv + 3, ua.indexOf('.', rv)), 10);
	}

	var edge = ua.indexOf('Edge/');
	if (edge > 0) {
		// Edge (IE 12+) => return version number
		return parseInt(ua.substring(edge + 5, ua.indexOf('.', edge)), 10);
	}

	// other browser
	return null;
  },

  _elapsed: function (date) {
      if (date && date !== '') {
			date = moment(date.toString(),'YYYY-MM-DD HH:mm:ss.SSS');
			var nowUtc = moment(moment.utc().format('YYYY-MM-DD HH:mm:ss.SSS'));
			var daysAgo = nowUtc.diff(date, 'days');
			var hoursAgo = nowUtc.diff(date, 'hours') - (daysAgo * 24);
			var minsAgo = nowUtc.diff(date, 'minutes') - (hoursAgo * 60) - (daysAgo * 24 * 60);
			var secsAgo = nowUtc.diff(date, 'seconds') - (minsAgo * 60) - (hoursAgo * 60 * 60) - (daysAgo * 24 * 60 * 60);
			daysAgo = daysAgo > 0 ? (daysAgo < 10 ? '0' : '') + daysAgo + (daysAgo > 1 ? 'd ' : 'd ') : '';
			hoursAgo = hoursAgo > 0 ? (hoursAgo < 10 ? '0' : '') + hoursAgo + (hoursAgo > 1 ? 'h ' : 'h ') : '00h ';
			minsAgo = minsAgo > 0 ? (minsAgo < 10 ? '0' : '') + minsAgo + (minsAgo > 1 ? 'm ' : 'm ') : '00m ';
			secsAgo = secsAgo > 0 ? (secsAgo < 10 ? '0' : '') + secsAgo + (secsAgo > 1 ? 's ' : 's ') : '00s ';
			return (daysAgo !== '' ? daysAgo : '') + (hoursAgo !== '' ? hoursAgo : '') + (minsAgo !== '' ? minsAgo : '') + secsAgo + 'ago'; // + (secsAgo)))) + ' Ago';
		}
		return '';
  },

	showTabs: function () {
      this._tabsShowing = true;
      this.animationConfig.entry[0].node = this.querySelector('zawarski-paper-tabs');
      this.playAnimation('entry');
  },
  // Tab time *sigh*
  _addTab: function(data) {
    if(typeof data == "number")
      return;
  //grab resizable window
    this._paperTabs = this.querySelector('zawarski-paper-tabs');
    this._pvisionForm = Polymer.dom(this.root).querySelector('#' + this.elementType + 'Form');
    this._pvisionForm.style.display = "block";
    this._pvisionForm.style.position = "relative";
    this._pvisionForm.style.height = "100%";
    this._pvisionForm.style.width = "100%";
    var dataId = data.pvDataID;
    if(typeof dataId == "undefined") {
          // Setting undefined dareta id to negative will return an empty form.
        dataId = moment.utc().unix() * -1;
      } else if (dataId == null) {
        return;
      } else if (dataId < 0) {
          // If data id is already negative, this will return a new form
        // with the values in data pre-populating it.
        this._pvisionForm.forms[dataId] = data;
      }
    this.currentDataId = dataId;

    var paperTabID =  this.elementType + '-tab-' + dataId;

    var paperTab, paperSpan;
    // See if a tab already exists for this entry.
    paperTab = Polymer.dom(this._paperTabs).querySelector('#' + paperTabID);
    if (paperTab != null) {
        // It does. Get the associated <zawarski-paper-tab>
        // paperTab = Polymer.dom(this.root).querySelector('#' + paperTabID);
        // Setting _selectedTabIndex to the index of zawarski-paper-tab in zawarski-paper-tabs will
        // call _onSelectedTabIndexChange to be called.
        this._selectedTabIndex = this._paperTabs.indexOf(paperTab);
        var window = document.querySelector('palmetto-resizable-window-new#' + this.elementType + 'Window');
        if (window) {
            window.show();
        }
        return;
    }

    paperTab = document.createElement('zawarski-paper-tab');
    paperSpan = document.createElement('div');
    paperSpan.style.width = "100%";
    paperSpan.style.whiteSpace = "nowrap";
    paperSpan.style.textOverflow = "ellipsis";
    paperSpan.style.overflow = "hidden";
    paperSpan.id = paperTabID + "-title";
    if(this._rowdata && this._rowdata.elementType == "admin-users"){
      if(this._rowdata.ncPersonMiddleName == "null")
            this._rowdata.ncPersonMiddleName = "";
      paperSpan.innerHTML = this._rowdata.ncPersonGivenName + " " + this._rowdata.ncPersonMiddleName + " " + this._rowdata.ncPersonSurName;
      this.querySelector("#admin-usersForm").editMessage = undefined;
    }

    paperTab.id = paperTabID;
    paperTab.closeable = true;
    // Add title.
    paperTab.appendChild(paperSpan);
    // Add new <zawarski-paper-tab> to <zawarski-paper-tabs>
    Polymer.dom(this._paperTabs).appendChild(paperTab);
    // Setting _selectedTabIndex to new tab will cause
    // _onSelectChange to be called.
    var that = this;
    setTimeout(function () {
       that._selectedTabIndex = that._paperTabs.items.length - 1;
    }.bind(this), 1);
    var footer = this.$.footer;
    if(footer && footer.tagName == "FOOTER-RESOURCE-SUMMARY")
        this.$.footer.fire('newResourceTab');
    else if(footer && footer.tagName == "FOOTER-SHELTER-SUMMARY")
        this.$.footer.fire('newShelterTab');
    else if(footer && footer.tagName == "FOOTER-MISSIONS-SUMMARY")
        this.$.footer.fire('newMissionsTab');
  },
  _closeTab: function(dataID) {

  },
  hideTabs: function () {
      this.animationConfig.exit[0].node = this.querySelector('zawarski-paper-tabs');
      this.playAnimation('exit');
      this._tabsShowing = false;
  },
  removeTab: function(e) {
      //get dataID id and get the tab section
      var pvDataID = e.detail.id.substring(e.detail.id.indexOf("-tab")+5);
      var _paperTabs = this.$.paperTabs;
      if(!_paperTabs) return;
      //if tab exists
      if(e.detail.tab) {
          //clear form
          var pvForm = this.querySelector("#"+this.elementType+"Form");
          if(pvForm) pvForm.clearEntry(pvDataID);
          //close the tab
          Polymer.dom(_paperTabs).removeChild(e.detail.tab);
          //load footer if there is any
          if(_paperTabs.selected == 1) {
              switch(this.elementType) {
                  case "shelters":
                    this.querySelector('footer-shelter-summary').fire('restoreFooter');
                    break;
                  case "resourcerequests":
                    this.querySelector('footer-resource-summary').fire('restoreFooter');
                    break;
              }
          }
          //select grid page
          _paperTabs.selectIndex(0);
        //   if(_paperTabs.selected == _paperTabs.items.length - 1) {
        //   }
      }
      //if no more tabs, hide tab section
      if(Polymer.dom(_paperTabs).children.length == 1) {
          this.hideTabs();
          //add iron resize to end of queue after animations
          setTimeout(function(e) {
              this._onIronResize();
          }.bind(this),1);
      }
  },
  _viewColumns: function(e) {
  },
  _columnDropdownItem: function(e) {
    var grid = $(this.$$("#kendo").$.grid).data("kendoGrid");
    if(!e.target.checked) {
      grid.hideColumn(e.target.data);
    } else {
      grid.showColumn(e.target.data);
    }
  },
  _getLoginToken: function(palmettoToken) {
    var obj = {"access_token":(palmettoToken.id)};
    return obj;
  },
  _getErrorMsg: function(event) {
    var status = "";
    if(event.detail.request.xhr.response) {
      try {
        resp = JSON.parse(event.detail.request.xhr.response);
        status = resp.error.message;
      } catch (err) {
        resp = event.detail.request.xhr.response.error.message;
        status = resp;
      }
    }
    return status;
  },
  ready: function(){
    window.addEventListener("palmetto-app-excel-event",function(e){
      this.ajaxResponse(e);
    }.bind(this));
    window.addEventListener("small-window-maximize-app",function(e){
      if(e.detail && e.detail.indexOf("Window") >= 0 ) {
          var elementType = e.detail.substring(0,e.detail.indexOf("Window"));
          if(this.elementType === elementType) {
            setTimeout(function(){
              this.maximize();
            }.bind(this),200);
          }
      }
    }.bind(this));

  },
  serviceActionsChanged: function(serviceActions) {
    if(!serviceActions || !serviceActions.base) return;
    for(var i = 0; i < serviceActions.base.length; i++) {
        if(serviceActions.base[i].pvActionName != "READ" && serviceActions.base[i].pvServiceID == this.serviceID) {
            this.set("hideAdd",false);
            return;
        }
    }
    this.set("hideAdd",true);
  },

   _retrieveAppTitle: function (serviceActions) {
		if (this.serviceActions && this.serviceActions.length > 0) {
			for (var i = 0; i < this.serviceActions.length; i++) {
				if (this.serviceActions[i].pvServiceID === this.serviceID) {
					this.set('serviceTitle', this.serviceActions[i].pvServiceTitle);
					break;
				}
			}
		}
	},

    /**
     * This function will check if the serviceActions for an app contains the desired action
     *@param {Array} serviceActions The list of serviceActions for an application
     *@param {String} actionName The action we are looking for
     *@returns {Boolean} If the service contain that permission
    */
  hasPermission: function(serviceActions,actionName) {
    if(!serviceActions || !serviceActions.base) return false;
    for(var i = 0; i < serviceActions.base.length; i++) {
        if(serviceActions.base[i].pvActionName.toLowerCase() === actionName.toLowerCase() && serviceActions.base[i].pvServiceID == this.serviceID) {
            return true;
        }
    }
    return false;
  },
  /**
   * This function will sets the helpPage for the element which is receieves from /api/settings
   * @Param {Event} e The response from the backend
   */
  getHelppage: function(e) {
    if (e.detail.status === 200 && e.detail.response && e.detail.response.length > 0) {
      this.set("pvSavedColumnSettingsID", e.detail.response[0].pvSettingID);
        var markdownString = e.detail.response[0].pvSettingValue;
        //Incase \n is renderred, replace it with \n
        markdownString = markdownString.replace(/\\n/g, '\n');
      this.set(this.elementType + 'Markdown', markdownString);
    }
  },
  getHelppageError: function(e) {
    console.error('Error getting the help page', e);
},

  hasPermissionPlain: function(serviceActions,actionName) {
    if(!serviceActions) return false;
    for(var i = 0; i < serviceActions.length; i++) {
        if(serviceActions[i].pvActionName.toLowerCase() === actionName.toLowerCase() && serviceActions[i].pvServiceID == this.serviceID) {
            return true;
        }
    }
    return false;
  },
  _removeApp: function () {
	if (this.parentNode.removeApp !== undefined) {
		this.parentNode.removeApp(this);
	}
  },

	_valueIsGTzero: function (val) {
		val = val && !isNaN(val) ? parseInt(val) : 0;
		return val > 0;
	},

	_getYesNo: function (val) {
		return val ? 'Yes' : 'No';
	},

	_valueIsYes: function (val) {
		return val === '1' || val === 1 ? true : null;
	},

	_valueIsNo: function (val) {
		return (val && (val === '0' || val === 0)) ? true : null;
	},

	_yesOrNo: function (val) {
		return val === '1' || val === 1 ? 'Yes' : 'No';
	},

	_convertToTitleCase: function (str) {
		if (str && str.toLowerCase) {
			str = str.toLowerCase();
			str = str.replace(/(^|\s|-|_)\S/g, function (t) {
				return t.toUpperCase();
			});
			str = str.replace(/\s*_+|-+\s*/g,'-');

			str = str.replace(' Of ', ' of ').replace('Mcc', 'McC');
		}
		return str;
	},

  _checkHiddenEntry: function (item) {
		if (item && item.pvIsHidden) {
			return "rgb(68, 68, 68); opacity: 0.54";
		}
		return "rgb(68, 68, 68);";
	}

};


</script>
